#ifndef FFMPEG_H
#define FFMPEG_H

#ifdef __cplusplus
extern "C" {
#endif//__cplusplus

#define LIBFFMPEG_SO_VERSION_MAJOR 1
#define LIBFFMPEG_SO_VERSION_MINOR 1
#define LIBFFMPEG_SO_VERSION_MICRO 0

#define S_OK							0x00000000
#define S_OK_INTERRUPTED					0x00000200
#define S_NO_OUTPUT_FILE					0x00000201
#define ERR_AV_INTERLEAVED_WRITE_FRAME				0x80000001
#define ERR_VIDEO_ENCODING_FAILED					0x80000002
#define ERR_VIDEO_STATE_FILE_OPEN_FAILED			0x80000003
#define ERR_OUTPUTFILE_NOT_CONTAIN_ANY_STREAM		0x80000004
#define ERR_NUMOFSTREAMS_NOT_MATCH_STREAMMAPS		0x80000005
#define ERR_COULD_NOT_FIND_INPUTSTREAM				0x80000006
#define ERR_COULD_NOT_FIND_SYNCSTREAM				0x80000007
#define ERR_CODEC_TYPE_MISMATCH						0x80000008
#define ERR_COULD_NOT_FIND_MATCHING_INPUTSTREAM_TO_OUTPUTSTREAM	0x80000009
#define ERR_FRAMES_ARE_NOT_DECODED					0x8000000a
#define ERR_CANNOT_ALLOC_TEMP_PICT_CHECK_PIX_FMT	0x8000000b
#define ERR_CANNOT_GET_RESAMPLING_CONTEXT			0x8000000c
#define ERR_COULD_NOT_OPEN_LOGFILE_WRITE			0x8000000d
#define ERR_COULD_NOT_OPEN_LOGFILE_READ				0x8000000e
#define ERR_COULD_NOT_ALLOC_LOG_BUFF				0x8000000f
#define ERR_UNSUPPORTED_CODEC_FOR_OUTPUT_STREAM		0x80000010
#define ERR_OUTPUT_AV_CODEC_OPEN_FAILED				0x80000011
#define ERR_UNSUPPORTED_CODEC_FOR_INPUT_STREAM		0x80000012
#define ERR_INPUT_AV_CODEC_OPEN_FAILED				0x80000013
#define ERR_UNKNOWN_IN_OR_OUT_FORMAT				0x80000014
#define ERR_INCORRECT_FRAME_RATE					0x80000015
#define ERR_INCORRECT_CROPSIZE						0x80000016
#define ERR_INCORRECT_FRAME_SIZE					0x80000017
#define ERR_INCORRECT_PADSIZE						0x80000018
#define ERR_UNSUPPORTED_OPT							0x80000019
#define ERR_UNSUPPORTED_OPT_FAILED					0x8000001a
#define ERR_INCORRECT_ASPECT_RATIO					0x8000001b
#define ERR_INCORRECT_QSCALE						0x8000001c
#define ERR_INNCORECT_QDIFF							0x8000001d
#define ERR_PARSE_TIME_OR_DAY_FAILED				0x8000001e
#define ERR_UNKNOWN_CODEC							0x8000001f
#define ERR_UNKNOWN_CODEC_TYPE						0x80000020
#define ERR_COULD_NOT_OPEN_INPUTFILE				0x80000021
#define ERR_COULD_NOT_FIND_CODEC_PARAM				0x80000022
#define ERR_COULD_NOT_ALLOC_VIDEO_STREAM			0x80000023
#define ERR_ERROR_PARSING_RC_OVERRIDE				0x80000024
#define ERR_COULD_NOT_ALLOC_AUDIO_STREAM			0x80000025
#define ERR_COULD_NOT_ALLOC_SUBTITILE_STREAM		0x80000026
#define ERR_NO_OUTPUT_FILE							0x80000027
#define ERR_OUTPUTFORMAT_NOT_FOUND_BY_FILE			0x80000028
#define ERR_COULD_NOT_READ_STREAM_PARAM				0x80000029
#define ERR_FILENUMBER_FAILED						0x8000002a
#define ERR_FILE_EXISTING							0x8000002b
#define ERR_FILE_NOT_OPENED							0x8000002c
#define ERR_INVALID_ENCODING_PARAMS					0x8000002d
#define ERR_INCORRECT_PASS_NUMBER					0x8000002e
#define ERR_SYNTAX_ERROR_IN_MATRIX					0x8000002f
#define ERR_COULD_NOT_DETERMINE_NORM				0x80000030
#define ERR_UNKNOWN_TARGET							0x80000031
#define ERR_UNKNOWN_BITSTREAM_FILETER				0x80000032
#define ERR_ARRAY_TOO_BIG							0x80000033
#define ERR_COULD_NOT_ALLOC_BUFFER					0x80000034
#define ERR_COULD_NOT_ALLOC_CODEC_CONTEXT			0x80000035
#define ERR_AV_BITSTREAM_FILTER_FAILED				0x80000036
#define ERR_BUFFER_SIZE_TOO_LARGE					0x80000037
#define ERR_OUT_OF_MEMORY_IN_AUDIO_INPUT			0x80000038
#define ERR_CAN_NOT_RESAMPLE_AUDIO					0x80000039
#define ERR_CANNOT_CONVERT_SAMPLE_FORMAT			0x8000003a
#define ERR_AV_AUDIO_CONVERT_FAILED					0x8000003b
#define ERR_AV_FIFO_REALLOC2_FAILED					0x8000003c
#define ERR_AUDIO_ENCODING_FAILED					0x8000003d
#define ERR_BUFFER_SIZE_TOO_SMALL					0x8000003e
#define ERR_SUBTITLE_PACKETS_MUST_HAVE_A_PTS		0x8000003f
#define ERR_SUBTITLE_ENCODING_FAILED				0x80000040
#define ERR_CAN_NOT_RESAMPLE_VIDEO					0x80000041
#define ERR_AUDIO_BUFFER_OVERFLOW					0x80000042
#define ERR_COULD_NOT_ALLOC_FORCED_KEY_FRAMES		0x80000043
#define ERR_INVALID_AUDIO_VOLUME					0x80000044
#define ERR_INVALID_PIXEL_FORMAT					0x80000045
#define ERR_TRANSCODE_FAILED						0x80000046
#define ERR_OPENING_FILTERS_FAILED					0x80000047
#define ERR_WHILE_DECODING_STREAM					0x80000048
#define ERR_INVALID_METADATA_OPTION					0x80000049
#define ERR_INVALID_AUDIO_SAMPLE_FORMAT_OPTION		0x8000004a
#define ERR_MAX_STREAMS_EXCEEDED					0x8000004b
#define ERR_CODEC_IS_EXPERIMENTAL					0x8000004c
#define ERR_PROGRAM_NOT_FOUND						0x8000004d
#define ERR_COULD_NOT_ALLOC_OUTPUT_STREAM			0x8000004e
#define ERR_INVALID_STREAM_ID_OPTION				0x8000004f
#define ERR_COULD_NOT_ALLOC_FORMAT_CONTEXT			0x80000050
#define ERR_REQUESTED_OUTPUT_FORMAT_IS_NOT_SUITABLE	0x80000051
#define ERR_READ_FFSERVER_STREAMS_FAILED			0x80000052
#define ERR_PRESET_NOT_FOUND						0x80000053
#define ERR_INVALID_PRESET_SYNTAX					0x80000054
#define ERR_ARGUMENT_REQUIRED						0x80000055
#define ERR_NO_INPUT_FILE						0x80000056

typedef enum {
	CALLBACK_VALUE_TYPE_RESULT,
	CALLBACK_VALUE_TYPE_DURATION,
	CALLBACK_VALUE_TYPE_PROGRESS,
	CALLBACK_VALUE_TYPE_RESOLUTION,
	CALLBACK_VALUE_TYPE_DAR,
	CALLBACK_VALUE_TYPE_PAR,
	CALLBACK_VALUE_TYPE_V_BIT_RATE,
	CALLBACK_VALUE_TYPE_FRAME_RATE,
	CALLBACK_VALUE_TYPE_A_BIT_RATE,
	CALLBACK_VALUE_TYPE_SAMPLING_RATE,
	CALLBACK_VALUE_TYPE_CHANNEL,
	CALLBACK_VALUE_TYPE_STREAM_INFO,
	CALLBACK_VALUE_TYPE_FORMAT_INFO,
} FF_CALLBACK_TYPE;

typedef struct {
	int file_id;
	int stream_id;
	union {
		int32_t l;
		double d;
		char *str;
		int64_t ll;
	} val;
} ff_callback_t;

typedef int ff_callback_func(void *p, FF_CALLBACK_TYPE type, ff_callback_t value);

extern int ffmain(ff_callback_func *func, void *p, int argc, char **argv);

#ifdef __cplusplus
}
#endif//__cplusplus

#endif//FFMPEG_H

